VSTGUI 4.5 Graphical User Interface Framework not only for VST plugins

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends Groups Pages
Classes | Public Types | Public Member Functions | Protected Member Functions | List of all members
CFrame Class Referencefinal
Container Views

The CFrame is the parent container of all views. More...

Inheritance diagram for CFrame:

## Classes
struct | CollectInvalidRects
struct | Impl

## Public Types
using | Function = std::function< void()>
Public Types inherited from CViewContainer
using | ViewList = std::list< SharedPointer< CView >>
using | ChildViewConstIterator = ViewList::const_iterator
using | ChildViewConstReverseIterator = ViewList::const_reverse_iterator
Public Types inherited from CView
enum | MouseListenerCall { MouseDown, MouseMoved, MouseUp, MouseCancel }

## Public Member Functions
| CFrame (const CRect &size, VSTGUIEditorInterface *pEditor)
bool | doAfterEventProcessing (Function &&func)
| Queue a function which will be executed after the current event was handled. More...
bool | doAfterEventProcessing (const Function &func)
| Queue a function which will be executed after the current event was handled. More...
bool | inEventProcessing () const
| Returns true if an event is currently being processed. More...
void | onStartLocalEventLoop ()
void | invalid () override
| mark whole view as invalid More...
void | invalidRect (const CRect &rect) override
| mark rect as invalid More...
bool | removeView (CView *pView, bool withForget=true) override
| remove a child view More...
bool | removeAll (bool withForget=true) override
| remove all child views More...
CView * | getViewAt (const CPoint &where, const GetViewOptions &options=GetViewOptions()) const override
| get the view at point where More...
CViewContainer * | getContainerAt (const CPoint &where, const GetViewOptions &options=GetViewOptions().deep()) const override
| get the container at point where More...
bool | hitTestSubViews (const CPoint &where, const CButtonState &buttons=-1) override
bool | attached (CView *parent) override
| view is attached to a parent view More...
void | draw (CDrawContext *pContext) override
| called if the view should draw itself More...
void | drawRect (CDrawContext *pContext, const CRect &updateRect) override
| called if the view should draw itself More...
CMouseEventResult | onMouseDown (CPoint &where, const CButtonState &buttons) override
| called when a mouse down event occurs More...
CMouseEventResult | onMouseUp (CPoint &where, const CButtonState &buttons) override
| called when a mouse up event occurs More...
CMouseEventResult | onMouseMoved (CPoint &where, const CButtonState &buttons) override
| called when a mouse move event occurs More...
CMouseEventResult | onMouseExited (CPoint &where, const CButtonState &buttons) override
| called when the mouse leaves this view More...
bool | onWheel (const CPoint &where, const float &distance, const CButtonState &buttons) override
| called if a mouse wheel event is happening over this view More...
bool | onWheel (const CPoint &where, const CMouseWheelAxis &axis, const float &distance, const CButtonState &buttons) override
| called if a mouse wheel event is happening over this view More...
int32_t | onKeyDown (VstKeyCode &keyCode) override
| called if a key down event occurs and this view has focus More...
int32_t | onKeyUp (VstKeyCode &keyCode) override
| called if a key up event occurs and this view has focus More...
void | setViewSize (const CRect &rect, bool invalid=true) override
| set views size More...
VSTGUIEditorInterface * | getEditor () const override
| get editor More...
IPlatformFrame * | getPlatformFrame () const
CBaseObject * | newCopy () const override
Focus Drawing Methods [new in 4.0]
If focus drawing is enabled, the focus view will get a focus ring around it defined with the focus width and the focus color. Views can define their own shape with the IFocusDrawing interface.
void | setFocusDrawingEnabled (bool state)
| enable focus drawing More...
bool | focusDrawingEnabled () const
| is focus drawing enabled More...
void | setFocusColor (const CColor &color)
| set focus draw color More...
CColor | getFocusColor () const
| get focus draw color More...
void | setFocusWidth (CCoord width)
| set focus draw width More...
CCoord | getFocusWidth () const
| get focus draw width More...
Public Member Functions inherited from CViewContainer
| CViewContainer (const CRect &size)
| CViewContainer constructor. More...
| CViewContainer (const CViewContainer &viewContainer)
virtual bool | invalidateDirtyViews ()
virtual CRect | getVisibleSize (const CRect &rect) const
void | setTransform (const CGraphicsTransform &t)
const CGraphicsTransform & | getTransform () const
void | registerViewContainerListener (IViewContainerListener *listener)
void | unregisterViewContainerListener (IViewContainerListener *listener)
void | draw (CDrawContext *pContext) override
void | drawRect (CDrawContext *pContext, const CRect &updateRect) override
CMouseEventResult | onMouseDown (CPoint &where, const CButtonState &buttons) override
| called when a mouse down event occurs More...
CMouseEventResult | onMouseUp (CPoint &where, const CButtonState &buttons) override
| called when a mouse up event occurs More...
CMouseEventResult | onMouseMoved (CPoint &where, const CButtonState &buttons) override
| called when a mouse move event occurs More...
CMouseEventResult | onMouseCancel () override
| called when mouse tracking should be canceled More...
bool | onWheel (const CPoint &where, const float &distance, const CButtonState &buttons) override
| called if a mouse wheel event is happening over this view More...
bool | onWheel (const CPoint &where, const CMouseWheelAxis &axis, const float &distance, const CButtonState &buttons) override
| called if a mouse wheel event is happening over this view More...
bool | hitTest (const CPoint &where, const CButtonState &buttons=-1) override
CMessageResult | notify (CBaseObject *sender, IdStringPtr message) override
SharedPointer< IDropTarget > | getDropTarget () override
| get the drag target for drag and drop handling More...
void | looseFocus () override
| called if view should loose focus More...
void | takeFocus () override
| called if view should take focus More...
bool | isDirty () const override
| check if view is dirty More...
void | invalid () override
| mark whole view as invalid More...
void | invalidRect (const CRect &rect) override
| mark rect as invalid More...
void | setViewSize (const CRect &rect, bool invalid=true) override
void | parentSizeChanged () override
| notification that one of the views parent has changed its size More...
bool | sizeToFit () override
| resize view to optimal size More...
bool | removed (CView *parent) override
| view is removed from parent view More...
bool | attached (CView *parent) override
| view is attached to a parent view More...
CPoint & | frameToLocal (CPoint &point) const override
| conversion from frame coordinates to local view coordinates More...
CPoint & | localToFrame (CPoint &point) const override
| conversion from local view coordinates to frame coordinates More...
CBaseObject * | newCopy () const override
CViewContainer * | asViewContainer () final
const CViewContainer * | asViewContainer () const final
bool | addView (CView *pView, const CRect &mouseableArea, bool mouseEnabled=true)
| add a child view More...
virtual bool | addView (CView *pView, CView *pBefore=nullptr)
| add a child view before another view More...
bool | isChild (CView *pView) const
| check if pView is a child view of this container More...
virtual bool | isChild (CView *pView, bool deep) const
| check if pView is a child view of this container More...
virtual bool | hasChildren () const
| check if container has child views More...
virtual uint32_t | getNbViews () const
| get the number of child views More...
virtual CView * | getView (uint32_t index) const
| get the child view at index More...
virtual bool | getViewsAt (const CPoint &where, ViewList &views, const GetViewOptions &options=GetViewOptions().deep()) const
| get all views at point where, top->down More...
virtual bool | changeViewZOrder (CView *view, uint32_t newIndex)
| change view z order position More...
virtual void | setAutosizingEnabled (bool state)
| enable or disable autosizing subviews. More...
bool | getAutosizingEnabled () const
template<class ViewClass , class ContainerClass >
uint32_t | getChildViewsOfType (ContainerClass &result, bool deep=false) const
| get child views of type ViewClass. More...
template<typename Proc >
void | forEachChild (Proc proc) const
| execute proc for each child view More...
virtual void | setBackgroundColor (const CColor &color)
| set the background color (will only be drawn if this container is not set to transparent and does not have a background bitmap) More...
virtual CColor | getBackgroundColor () const
| get the background color More...
virtual void | setBackgroundOffset (const CPoint &p)
| set the offset of the background bitmap More...
virtual CPoint | getBackgroundOffset () const
| get the offset of the background bitmap More...
virtual void | drawBackgroundRect (CDrawContext *pContext, const CRect &_updateRect)
| draw the background More...
virtual void | setBackgroundColorDrawStyle (CDrawStyle style)
CDrawStyle | getBackgroundColorDrawStyle () const
Public Member Functions inherited from CView
| CView (const CRect &size)
| CView (const CView &view)
void | setSubviewState (bool state)
bool | isSubview () const
virtual bool | wantsWindowActiveStateChangeNotification () const
| whether this view wants to be informed if the window's active state changes More...
virtual void | onWindowActivate (bool state)
| called when the active state of the window changes More...
void | setTooltipText (UTF8StringPtr text)
CMouseEventResult | callMouseListener (MouseListenerCall type, CPoint pos, CButtonState buttons)
void | callMouseListenerEnteredExited (bool mouseEntered)
CBaseObject * | newCopy () const override
virtual CMouseEventResult | onMouseEntered (CPoint &where, const CButtonState &buttons)
| called when the mouse enters this view More...
void | setHitTestPath (CGraphicsPath *path)
virtual void | setMouseEnabled (bool bEnable=true)
| turn on/off mouse usage for this view More...
bool | getMouseEnabled () const
| get the state of wheather this view uses the mouse or not More...
virtual void | setMouseableArea (const CRect &rect)
| set the area in which the view reacts to the mouse More...
CRect & | getMouseableArea (CRect &rect) const
| get the area in which the view reacts to the mouse More...
const CRect & | getMouseableArea () const
| read only access to the mouseable area More...
bool | doDrag (const DragDescription &dragDescription, const SharedPointer< IDragCallback > &callback={})
| start a drag operation More...
void | setDropTarget (const SharedPointer< IDropTarget > &dt)
| set a custom drop target More...
DragResult | doDrag (IDataPackage *source, const CPoint &offset=CPoint(0, 0), CBitmap *dragBitmap=nullptr)
| a drag can only be started from within onMouseDown More...
CCoord | getHeight () const
| get the height of the view More...
CCoord | getWidth () const
| get the width of the view More...
const CRect & | getViewSize () const
| read only access to view size More...
virtual CRect | getVisibleViewSize () const
| returns the visible size of the view More...
virtual void | setAutosizeFlags (int32_t flags)
| set autosize flags More...
int32_t | getAutosizeFlags () const
| get autosize flags More...
virtual bool | wantsFocus () const
| check if view supports focus More...
virtual void | setWantsFocus (bool state)
| set focus support on/off More...
bool | getAttributeSize (const CViewAttributeID id, uint32_t &outSize) const
| get the size of an attribute More...
bool | getAttribute (const CViewAttributeID id, const uint32_t inSize, void *outData, uint32_t &outSize) const
| get an attribute More...
bool | setAttribute (const CViewAttributeID id, const uint32_t inSize, const void *inData)
| set an attribute More...
bool | removeAttribute (const CViewAttributeID id)
| remove an attribute More...
template<typename T >
bool | setAttribute (const CViewAttributeID id, const T &data)
| set an attribute More...
template<typename T >
bool | getAttribute (const CViewAttributeID id, T &data) const
| get an attribute More...
virtual void | setBackground (CBitmap *background)
| set the background image of this view More...
CBitmap * | getBackground () const
| get the background image of this view More...
virtual void | setDisabledBackground (CBitmap *background)
| set background image used when the mouse is not enabled More...
CBitmap * | getDisabledBackground () const
| get background image used when the mouse is not enabled More...
CBitmap * | getDrawBackground () const
| get the bitmap which is drawn depending on the enabled state. More...
virtual void | setTransparency (bool val)
| set views transparent state More...
bool | getTransparency () const
| get views transparent state More...
virtual void | setAlphaValue (float alpha)
| set alpha value which will be applied when drawing this view More...
float | getAlphaValue () const
| get alpha value More...
bool | isAttached () const
| is view attached to a parentView More...
CView * | getParentView () const
| get parent view More...
CFrame * | getFrame () const
| get frame More...
void | addAnimation (IdStringPtr name, Animation::IAnimationTarget *target, Animation::ITimingFunction *timingFunction, CBaseObject *notificationObject=nullptr)
void | addAnimation (IdStringPtr name, Animation::IAnimationTarget *target, Animation::ITimingFunction *timingFunction, const Animation::DoneFunction &doneFunc)
void | removeAnimation (IdStringPtr name)
void | removeAllAnimations ()
void | registerViewListener (IViewListener *listener)
void | unregisterViewListener (IViewListener *listener)
void | registerViewMouseListener (IViewMouseListener *listener)
void | unregisterViewMouseListener (IViewMouseListener *listener)
CGraphicsTransform | getGlobalTransform () const
| get the active global transform for this view More...
template<typename T >
T & | translateToGlobal (T &t) const
| translates a local coordinate to a global one using parent transforms More...
template<typename T >
T | translateToGlobal (const T &t) const
| translates a local coordinate to a global one using parent transforms More...
template<typename T >
T & | translateToLocal (T &t) const
| translates a global coordinate to a local one using parent transforms More...
template<typename T >
T | translateToLocal (const T &t) const
| translates a local coordinate to a global one using parent transforms More...
virtual bool | checkUpdate (const CRect &updateRect) const
virtual void | setDirty (bool val=true)
| set the view to dirty so that it is redrawn in the next idle. More...
virtual void | setVisible (bool state)
| set visibility state More...
bool | isVisible () const
| get visibility state More...
virtual void | onIdle ()
| called on idle when view wants idle More...
void | setWantsIdle (bool state)
| enable/disable onIdle() callback More...
bool | wantsIdle () const
| returns if the view wants idle callback or not More...
Public Member Functions inherited from CBaseObject
| CBaseObject ()=default
| ~CBaseObject () noexceptoverride=default
| CBaseObject (const CBaseObject &o)
CBaseObject & | operator= (const CBaseObject &obj)
Public Member Functions inherited from ReferenceCounted< T >
| ReferenceCounted ()=default
virtual | ~ReferenceCounted () noexcept=default
| ReferenceCounted (const ReferenceCounted &)
ReferenceCounted & | operator= (const ReferenceCounted &)
void | forget () override
| decrease refcount and delete object if refcount == 0 More...
void | remember () override
| increase refcount More...
virtual int32_t | getNbReference () const
| get refcount More...

## Protected Member Functions
| ~CFrame () noexceptoverride=default
void | beforeDelete () override
void | checkMouseViews (const CPoint &where, const CButtonState &buttons)
void | clearMouseViews (const CPoint &where, const CButtonState &buttons, bool callMouseExit=true)
void | removeFromMouseViews (CView *view)
void | setCollectInvalidRects (CollectInvalidRects *collectInvalidRects)
int32_t | keyboardHooksOnKeyDown (const VstKeyCode &key)
int32_t | keyboardHooksOnKeyUp (const VstKeyCode &key)
void | callMouseObserverMouseEntered (CView *view)
void | callMouseObserverMouseExited (CView *view)
CMouseEventResult | callMouseObserverMouseDown (const CPoint &where, const CButtonState &buttons)
CMouseEventResult | callMouseObserverMouseMoved (const CPoint &where, const CButtonState &buttons)
void | dispatchNewScaleFactor (double newScaleFactor)
bool | platformDrawRect (CDrawContext *context, const CRect &rect) override
CMouseEventResult | platformOnMouseDown (CPoint &where, const CButtonState &buttons) override
CMouseEventResult | platformOnMouseMoved (CPoint &where, const CButtonState &buttons) override
CMouseEventResult | platformOnMouseUp (CPoint &where, const CButtonState &buttons) override
CMouseEventResult | platformOnMouseExited (CPoint &where, const CButtonState &buttons) override
bool | platformOnMouseWheel (const CPoint &where, const CMouseWheelAxis &axis, const float &distance, const CButtonState &buttons) override
DragOperation | platformOnDragEnter (DragEventData data) override
DragOperation | platformOnDragMove (DragEventData data) override
void | platformOnDragLeave (DragEventData data) override
bool | platformOnDrop (DragEventData data) override
bool | platformOnKeyDown (VstKeyCode &keyCode) override
bool | platformOnKeyUp (VstKeyCode &keyCode) override
void | platformOnActivate (bool state) override
void | platformOnWindowActivate (bool state) override
void | platformScaleFactorChanged (double newScaleFactor) override
Protected Member Functions inherited from CViewContainer
| ~CViewContainer () noexceptoverride
void | beforeDelete () override
virtual bool | checkUpdateRect (CView *view, const CRect &rect)
| check if view needs to be updated for rect More...
void | setMouseDownView (CView *view)
CView * | getMouseDownView () const
const ViewList & | getChildren () const
Protected Member Functions inherited from CView
| ~CView () noexceptoverride
CGraphicsPath * | getHitTestPath () const
bool | hasViewFlag (int32_t bit) const
void | setViewFlag (int32_t bit, bool state)
void | setAlphaValueNoInvalidate (float value)
void | setParentFrame (CFrame *frame)
void | setParentView (CView *parent)

## CFrame Methods
static int32_t | kDefaultKnobMode = kCircularMode
| default knob mode if host does not provide one More...
bool | open (void *pSystemWindow, PlatformType systemWindowType=kDefaultNative, IPlatformFrameConfig *=nullptr)
void | close ()
| closes the frame and calls forget More...
bool | setZoom (double zoomFactor)
| set zoom factor More...
double | getZoom () const
| get zoom factor More...
void | setBitmapInterpolationQuality (BitmapInterpolationQuality quality)
| set interpolation quality for bitmaps More...
BitmapInterpolationQuality | getBitmapInterpolationQuality () const
| get interpolation quality for bitmaps More...
double | getScaleFactor () const
void | idle ()
uint32_t | getTicks () const
| get the current time (in ms) More...
int32_t | getKnobMode () const
| get hosts knob mode More...
bool | setPosition (CCoord x, CCoord y)
| repositions the frame More...
bool | getPosition (CCoord &x, CCoord &y) const
| get global position of frame More...
bool | setSize (CCoord width, CCoord height)
| set size of frame (and the platform representation) More...
bool | getSize (CRect *pSize) const
| get size relative to parent More...
bool | getSize (CRect &pSize) const
bool | setModalView (CView *pView)
CView * | getModalView () const
ModalViewSession * | beginModalViewSession (CView *view)
bool | endModalViewSession (ModalViewSession *session)
void | beginEdit (int32_t index)
void | endEdit (int32_t index)
bool | getCurrentMouseLocation (CPoint &where) const
| get current mouse location More...
CButtonState | getCurrentMouseButtons () const
| get current mouse buttons and key modifiers More...
void | setCursor (CCursorType type)
| set mouse cursor More...
void | setFocusView (CView *pView)
CView * | getFocusView () const
bool | advanceNextFocusView (CView *oldFocus, bool reverse=false) override
void | onViewAdded (CView *pView)
void | onViewRemoved (CView *pView)
void | onActivate (bool state)
| called when the platform view/window is activated/deactivated More...
void | invalidate (const CRect &rect)
void | scrollRect (const CRect &src, const CPoint &distance)
| scroll src rect by distance More...
void | enableTooltips (bool state, uint32_t delayTimeInMs=1000)
| enable or disable tooltips More...
Animation::Animator * | getAnimator ()
| get animator for this frame More...
SharedPointer< IDataPackage > | getClipboard ()
| get the clipboard data. More...
void | setClipboard (const SharedPointer< IDataPackage > &data)
| set the clipboard data. More...
IViewAddedRemovedObserver * | getViewAddedRemovedObserver () const
void | setViewAddedRemovedObserver (IViewAddedRemovedObserver *observer)
void | registerKeyboardHook (IKeyboardHook *hook)
| register a keyboard hook More...
void | unregisterKeyboardHook (IKeyboardHook *hook)
| unregister a keyboard hook More...
void | registerMouseObserver (IMouseObserver *observer)
| register a mouse observer More...
void | unregisterMouseObserver (IMouseObserver *observer)
| unregister a mouse observer More...
void | registerScaleFactorChangedListeneer (IScaleFactorChangedListener *listener)
void | unregisterScaleFactorChangedListeneer (IScaleFactorChangedListener *listener)
void | registerFocusViewObserver (IFocusViewObserver *observer)
void | unregisterFocusViewObserver (IFocusViewObserver *observer)

## Additional Inherited Members
Static Public Attributes inherited from CView
static bool | kDirtyCallAlwaysOnMainThread = false
| if this is true, setting a view dirty will call invalid() instead of checking it in idle. More...
static uint32_t | idleRate
| global idle rate in Hz, defaults to 30 Hz More...
Protected Types inherited from CViewContainer
enum | { kAutosizeSubviews = 1 << (CView::kLastCViewFlag + 1) }
Protected Types inherited from CView
enum | { kMouseEnabled = 1 << 0, kTransparencyEnabled = 1 << 1, kWantsFocus = 1 << 2, kIsAttached = 1 << 3, kVisible = 1 << 4, kDirty = 1 << 5, kWantsIdle = 1 << 6, kIsSubview = 1 << 7, kLastCViewFlag = 7 }

## Detailed Description

The CFrame is the parent container of all views.

It creates a platform dependend view object.

On Mac OS X it is a HIView or NSView.
On Windows it's a WS_CHILD Window.

## Member Typedef Documentation

using Function = std::function<void ()>

## Constructor & Destructor Documentation

CFrame | ( | const CRect & | size,
|  | VSTGUIEditorInterface * | pEditor
| ) |  |

~CFrame | ( |  | ) |
| override protected default noexcept

## Member Function Documentation

bool advanceNextFocusView | ( | CView * | oldFocus,
|  | bool | reverse = `false`
| ) |  |
| override virtual

Parameters

  oldFocus | old focus view
  reverse | search order

Returns
  true on success

Reimplemented from CViewContainer.

bool attached | ( | CView * | parent | ) |
| override virtual

view is attached to a parent view

Parameters

  parent | parent view

Returns
  true if view successfully attached to parent

Reimplemented from CView.

void beforeDelete | ( |  | ) |
| override protected virtual

Reimplemented from ReferenceCounted< T >.

void beginEdit | ( | int32_t | index | ) |

ModalViewSession * beginModalViewSession | ( | CView * | view | ) |

CMouseEventResult callMouseObserverMouseDown | ( | const CPoint & | where,
|  | const CButtonState & | buttons
| ) |  |
| protected

void callMouseObserverMouseEntered | ( | CView * | view | ) |
| protected

void callMouseObserverMouseExited | ( | CView * | view | ) |
| protected

CMouseEventResult callMouseObserverMouseMoved | ( | const CPoint & | where,
|  | const CButtonState & | buttons
| ) |  |
| protected

void checkMouseViews | ( | const CPoint & | where,
|  | const CButtonState & | buttons
| ) |  |
| protected

void clearMouseViews | ( | const CPoint & | where,
|  | const CButtonState & | buttons,
|  | bool | callMouseExit = `true`
| ) |  |
| protected

void close | ( |  | ) |

closes the frame and calls forget

void dispatchNewScaleFactor | ( | double | newScaleFactor | ) |
| protected

bool doAfterEventProcessing | ( | Function && | func | ) |

Queue a function which will be executed after the current event was handled.

Only allowed when inEventProcessing () is true

Parameters

  func | Function to execute

Returns
  true if the function was added to the execution queue

bool doAfterEventProcessing | ( | const Function & | func | ) |

Queue a function which will be executed after the current event was handled.

Only allowed when inEventProcessing () is true

Parameters

  func | Function to execute

Returns
  true if the function was added to the execution queue

void draw | ( | CDrawContext * | pContext | ) |
| override virtual

called if the view should draw itself

Parameters

  pContext | draw context in which to draw

Reimplemented from CView.

void drawRect | ( | CDrawContext * | pContext,
|  | const CRect & | updateRect
| ) |  |
| override virtual

called if the view should draw itself

Reimplemented from CView.

void enableTooltips | ( | bool | state,
|  | uint32_t | delayTimeInMs = `1000`
| ) |  |

enable or disable tooltips

void endEdit | ( | int32_t | index | ) |

bool endModalViewSession | ( | ModalViewSession * | session | ) |

bool focusDrawingEnabled | ( |  | ) | const

is focus drawing enabled

Animation::Animator * getAnimator | ( |  | ) |

get animator for this frame

BitmapInterpolationQuality getBitmapInterpolationQuality | ( |  | ) | const

get interpolation quality for bitmaps

SharedPointer< IDataPackage > getClipboard | ( |  | ) |

get the clipboard data.

data is owned by the caller

CViewContainer * getContainerAt | ( | const CPoint & | p,
|  | const GetViewOptions & | options = `GetViewOptions ().deep ()`
| ) |  | const
| override virtual

get the container at point where

Parameters

  p | location
  options | search search options

Returns
  view container at position p or null

Reimplemented from CViewContainer.

CButtonState getCurrentMouseButtons | ( |  | ) | const

get current mouse buttons and key modifiers

Returns
  mouse and modifier state

bool getCurrentMouseLocation | ( | CPoint & | where | ) | const

get current mouse location

Parameters

  where | location of mouse

Returns
  true on success

VSTGUIEditorInterface * getEditor | ( |  | ) | const
| override virtual

get editor

Reimplemented from CView.

CColor getFocusColor | ( |  | ) | const

get focus draw color

CView * getFocusView | ( |  | ) | const

CCoord getFocusWidth | ( |  | ) | const

get focus draw width

int32_t getKnobMode | ( |  | ) | const

get hosts knob mode

CView * getModalView | ( |  | ) | const

IPlatformFrame * getPlatformFrame | ( |  | ) | const

bool getPosition | ( | CCoord & | x,
|  | CCoord & | y
| ) |  | const

get global position of frame

Parameters

  x | x coordinate
  y | y coordinate

Returns
  true on success

double getScaleFactor | ( |  | ) | const

bool getSize | ( | CRect * | pRect | ) | const

get size relative to parent

Parameters

  pRect | size

Returns
  true on success

bool getSize | ( | CRect & | pSize | ) | const

uint32_t getTicks | ( |  | ) | const

get the current time (in ms)

Returns
  tick count in milliseconds

IViewAddedRemovedObserver * getViewAddedRemovedObserver | ( |  | ) | const

CView * getViewAt | ( | const CPoint & | p,
|  | const GetViewOptions & | options = `GetViewOptions ()`
| ) |  | const
| override virtual

get the view at point where

Parameters

  p | location
  options | search options

Returns
  view at position p or null

Reimplemented from CViewContainer.

double getZoom | ( |  | ) | const

get zoom factor

bool hitTestSubViews | ( | const CPoint & | where,
|  | const CButtonState & | buttons = `-1`
| ) |  |
| override virtual

Parameters

  where | point
  buttons | mouse button and modifier state

Returns
  true if any sub view accepts the hit

Reimplemented from CViewContainer.

void idle | ( |  | ) |

bool inEventProcessing | ( |  | ) | const

Returns true if an event is currently being processed.

void invalid | ( |  | ) |
| inline override virtual

mark whole view as invalid

Reimplemented from CView.

void invalidate | ( | const CRect & | rect | ) |

void invalidRect | ( | const CRect & | rect | ) |
| override virtual

mark rect as invalid

Parameters

  rect | rect to invalidate

Reimplemented from CView.

int32_t keyboardHooksOnKeyDown | ( | const VstKeyCode & | key | ) |
| protected

int32_t keyboardHooksOnKeyUp | ( | const VstKeyCode & | key | ) |
| protected

CBaseObject* newCopy | ( |  | ) | const
| inline override

void onActivate | ( | bool | state | ) |

called when the platform view/window is activated/deactivated

int32_t onKeyDown | ( | VstKeyCode & | keyCode | ) |
| override virtual

called if a key down event occurs and this view has focus

Parameters

  keyCode | key code of pressed key

Returns
  -1 if not handled and 1 if handled

Reimplemented from CView.

int32_t onKeyUp | ( | VstKeyCode & | keyCode | ) |
| override virtual

called if a key up event occurs and this view has focus

Parameters

  keyCode | key code of pressed key

Returns
  -1 if not handled and 1 if handled

Reimplemented from CView.

CMouseEventResult onMouseDown | ( | CPoint & | where,
|  | const CButtonState & | buttons
| ) |  |
| override virtual

called when a mouse down event occurs

Parameters

  where | mouse location of mouse down
  buttons | button and modifier state

Returns
  event result. see CMouseEventResult

Reimplemented from CView.

CMouseEventResult onMouseExited | ( | CPoint & | where,
|  | const CButtonState & | buttons
| ) |  |
| override virtual

called when the mouse leaves this view

Reimplemented from CView.

CMouseEventResult onMouseMoved | ( | CPoint & | where,
|  | const CButtonState & | buttons
| ) |  |
| override virtual

called when a mouse move event occurs

Parameters

  where | mouse location of mouse move
  buttons | button and modifier state

Returns
  event result. see CMouseEventResult

Reimplemented from CView.

CMouseEventResult onMouseUp | ( | CPoint & | where,
|  | const CButtonState & | buttons
| ) |  |
| override virtual

called when a mouse up event occurs

Parameters

  where | mouse location of mouse up
  buttons | button and modifier state

Returns
  event result. see CMouseEventResult

Reimplemented from CView.

void onStartLocalEventLoop | ( |  | ) |

void onViewAdded | ( | CView * | pView | ) |

Parameters

  pView | view which was added

void onViewRemoved | ( | CView * | pView | ) |

Parameters

  pView | view which was removed

bool onWheel | ( | const CPoint & | where,
|  | const float & | distance,
|  | const CButtonState & | buttons
| ) |  |
| override virtual

called if a mouse wheel event is happening over this view

Parameters

  where | location
  distance | wheel distance
  buttons | button and modifier state

Returns
  true if handled

Reimplemented from CView.

bool onWheel | ( | const CPoint & | where,
|  | const CMouseWheelAxis & | axis,
|  | const float & | distance,
|  | const CButtonState & | buttons
| ) |  |
| override virtual

called if a mouse wheel event is happening over this view

Parameters

  where | location
  axis | mouse wheel axis
  distance | wheel distance
  buttons | button and modifier state

Returns
  true if handled

Reimplemented from CView.

bool open | ( | void * | pSystemWindow,
|  | PlatformType | systemWindowType = `kDefaultNative`,
|  | IPlatformFrameConfig * | config = `nullptr`
| ) |  |

bool platformDrawRect | ( | CDrawContext * | context,
|  | const CRect & | rect
| ) |  |
| override protected

void platformOnActivate | ( | bool | state | ) |
| override protected

DragOperation platformOnDragEnter | ( | DragEventData | data | ) |
| override protected

void platformOnDragLeave | ( | DragEventData | data | ) |
| override protected

DragOperation platformOnDragMove | ( | DragEventData | data | ) |
| override protected

bool platformOnDrop | ( | DragEventData | data | ) |
| override protected

bool platformOnKeyDown | ( | VstKeyCode & | keyCode | ) |
| override protected

bool platformOnKeyUp | ( | VstKeyCode & | keyCode | ) |
| override protected

CMouseEventResult platformOnMouseDown | ( | CPoint & | where,
|  | const CButtonState & | buttons
| ) |  |
| override protected

CMouseEventResult platformOnMouseExited | ( | CPoint & | where,
|  | const CButtonState & | buttons
| ) |  |
| override protected

CMouseEventResult platformOnMouseMoved | ( | CPoint & | where,
|  | const CButtonState & | buttons
| ) |  |
| override protected

CMouseEventResult platformOnMouseUp | ( | CPoint & | where,
|  | const CButtonState & | buttons
| ) |  |
| override protected

bool platformOnMouseWheel | ( | const CPoint & | where,
|  | const CMouseWheelAxis & | axis,
|  | const float & | distance,
|  | const CButtonState & | buttons
| ) |  |
| override protected

void platformOnWindowActivate | ( | bool | state | ) |
| override protected

void platformScaleFactorChanged | ( | double | newScaleFactor | ) |
| override protected

void registerFocusViewObserver | ( | IFocusViewObserver * | observer | ) |

void registerKeyboardHook | ( | IKeyboardHook * | hook | ) |

register a keyboard hook

void registerMouseObserver | ( | IMouseObserver * | observer | ) |

register a mouse observer

void registerScaleFactorChangedListeneer | ( | IScaleFactorChangedListener * | listener | ) |

bool removeAll | ( | bool | withForget = `true` | ) |
| override virtual

remove all child views

Parameters

  withForget | bool to indicate if the view's reference counter should be decreased after removed from the container

Returns
  true on success

Reimplemented from CViewContainer.

void removeFromMouseViews | ( | CView * | view | ) |
| protected

bool removeView | ( | CView * | pView,
|  | bool | withForget = `true`
| ) |  |
| override virtual

remove a child view

Parameters

  pView | the view which should be removed from the container
  withForget | bool to indicate if the view's reference counter should be decreased after removed from the container

Returns
  true on success

Reimplemented from CViewContainer.

void scrollRect | ( | const CRect & | src,
|  | const CPoint & | distance
| ) |  |

scroll src rect by distance

Parameters

  src | rect which to scroll
  distance | point of distance

void setBitmapInterpolationQuality | ( | BitmapInterpolationQuality | quality | ) |

set interpolation quality for bitmaps

void setClipboard | ( | const SharedPointer< IDataPackage > & | data | ) |

set the clipboard data.

void setCollectInvalidRects | ( | CollectInvalidRects * | collectInvalidRects | ) |
| protected

void setCursor | ( | CCursorType | type | ) |

set mouse cursor

Parameters

  type | cursor type see CCursorType

void setFocusColor | ( | const CColor & | color | ) |

set focus draw color

void setFocusDrawingEnabled | ( | bool | state | ) |

enable focus drawing

void setFocusView | ( | CView * | pView | ) |

Parameters

  pView | new focus view

void setFocusWidth | ( | CCoord | width | ) |

set focus draw width

bool setModalView | ( | CView * | pView | ) |

Parameters

  pView | the view which should be set to modal.

Returns
  true if view could be set as the modal view. false if there is a already a modal view or the view to be set as modal is already attached.

bool setPosition | ( | CCoord | x,
|  | CCoord | y
| ) |  |

repositions the frame

Parameters

  x | x coordinate
  y | y coordinate

Returns
  true on success

bool setSize | ( | CCoord | width,
|  | CCoord | height
| ) |  |

set size of frame (and the platform representation)

Parameters

  width | new width
  height | new height

Returns
  true on success

void setViewAddedRemovedObserver | ( | IViewAddedRemovedObserver * | observer | ) |

void setViewSize | ( | const CRect & | newSize,
|  | bool | doInvalid = `true`
| ) |  |
| override virtual

set views size

Parameters

  newSize | rect of new size of view
  doInvalid | if true set view dirty

Reimplemented from CView.

bool setZoom | ( | double | zoomFactor | ) |

set zoom factor

void unregisterFocusViewObserver | ( | IFocusViewObserver * | observer | ) |

void unregisterKeyboardHook | ( | IKeyboardHook * | hook | ) |

unregister a keyboard hook

void unregisterMouseObserver | ( | IMouseObserver * | observer | ) |

unregister a mouse observer

void unregisterScaleFactorChangedListeneer | ( | IScaleFactorChangedListener * | listener | ) |

## Member Data Documentation

int32_t kDefaultKnobMode = kCircularMode
| static

default knob mode if host does not provide one

The documentation for this class was generated from the following files:

- cframe.h
- cframe.cpp